# Class JFileChooser

java.lang.Object
java.awt.Component
java.awt.Container
javax.swing.JComponent
javax.swing.JFileChooser

All Implemented Interfaces:
  `ImageObserver, MenuContainer, Serializable, Accessible`

@JavaBean(defaultProperty="UI", description="A component which allows for the interactive selection of a file.") public class JFileChooser extends JComponent implements Accessible
`JFileChooser` provides a simple mechanism for the user to choose a file. For information about using `JFileChooser`, see How to Use File Choosers, a section in The Java Tutorial.

The following code pops up a file chooser for the user's home directory that sees only .jpg and .gif images:

       JFileChooser chooser = new JFileChooser();
       FileNameExtensionFilter filter = new FileNameExtensionFilter(
           "JPG & GIF Images", "jpg", "gif");
       chooser.setFileFilter(filter);
       int returnVal = chooser.showOpenDialog(parent);
       if(returnVal == JFileChooser.APPROVE_OPTION) {
          System.out.println("You chose to open this file: " +
               chooser.getSelectedFile().getName());
       }

Warning: Swing is not thread safe. For more information see Swing's Threading Policy.

Since:
  1.2

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`protected class`
`JFileChooser.AccessibleJFileChooser`
This class implements accessibility support for the `JFileChooser` class.

### Nested classes/interfaces declared in class JComponent

`JComponent.AccessibleJComponent`
Modifier and Type
Class
Description
`class`
`JComponent.AccessibleJComponent`
Inner class of JComponent used to provide default support for accessibility.

### Nested classes/interfaces declared in class Container

`Container.AccessibleAWTContainer`
Modifier and Type
Class
Description
`protected class`
`Container.AccessibleAWTContainer`
Inner class of Container used to provide default support for accessibility.

### Nested classes/interfaces declared in class Component

`Component.AccessibleAWTComponent, Component.BaselineResizeBehavior, Component.BltBufferStrategy, Component.FlipBufferStrategy`
Modifier and Type
Class
Description
`protected class`
`Component.AccessibleAWTComponent`
Inner class of Component used to provide default support for accessibility.
`static enum`
`Component.BaselineResizeBehavior`
Enumeration of the common ways the baseline of a component can change as the size changes.
`protected class`
`Component.BltBufferStrategy`
Inner class for blitting offscreen surfaces to a component.
`protected class`
`Component.FlipBufferStrategy`
Inner class for flipping buffers on a component.

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`ACCEPT_ALL_FILE_FILTER_USED_CHANGED_PROPERTY`
Identifies whether the AcceptAllFileFilter is used or not.
`protected AccessibleContext`
`accessibleContext`
`AccessibleContext` associated with this `JFileChooser`
`static final String`
`ACCESSORY_CHANGED_PROPERTY`
Says that a different accessory component is in use (for example, to preview files).
`static final String`
`APPROVE_BUTTON_MNEMONIC_CHANGED_PROPERTY`
Identifies change in the mnemonic for the approve (yes, ok) button.
`static final String`
`APPROVE_BUTTON_TEXT_CHANGED_PROPERTY`
Identifies change in the text on the approve (yes, ok) button.
`static final String`
`APPROVE_BUTTON_TOOL_TIP_TEXT_CHANGED_PROPERTY`
Identifies change in the tooltip text for the approve (yes, ok) button.
`static final int`
`APPROVE_OPTION`
Return value if approve (yes, ok) is chosen.
`static final String`
`APPROVE_SELECTION`
Instruction to approve the current selection (same as pressing yes or ok).
`static final int`
`CANCEL_OPTION`
Return value if cancel is chosen.
`static final String`
`CANCEL_SELECTION`
Instruction to cancel the current selection.
`static final String`
`CHOOSABLE_FILE_FILTER_CHANGED_PROPERTY`
Identifies a change in the list of predefined file filters the user can choose from.
`static final String`
`CONTROL_BUTTONS_ARE_SHOWN_CHANGED_PROPERTY`
Instruction to display the control buttons.
`static final int`
`CUSTOM_DIALOG`
Type value indicating that the `JFileChooser` supports a developer-specified file operation.
`static final String`
`DIALOG_TITLE_CHANGED_PROPERTY`
Identifies a change in the dialog title.
`static final String`
`DIALOG_TYPE_CHANGED_PROPERTY`
Identifies a change in the type of files displayed (files only, directories only, or both files and directories).
`static final int`
`DIRECTORIES_ONLY`
Instruction to display only directories.
`static final String`
`DIRECTORY_CHANGED_PROPERTY`
Identifies user's directory change.
`static final int`
`ERROR_OPTION`
Return value if an error occurred.
`static final String`
`FILE_FILTER_CHANGED_PROPERTY`
User changed the kind of files to display.
`static final String`
`FILE_HIDING_CHANGED_PROPERTY`
Identifies a change in the display-hidden-files property.
`static final String`
`FILE_SELECTION_MODE_CHANGED_PROPERTY`
Identifies a change in the kind of selection (single, multiple, etc.).
`static final String`
`FILE_SYSTEM_VIEW_CHANGED_PROPERTY`
Says that a different object is being used to find available drives on the system.
`static final String`
`FILE_VIEW_CHANGED_PROPERTY`
Says that a different object is being used to retrieve file information.
`static final int`
`FILES_AND_DIRECTORIES`
Instruction to display both files and directories.
`static final int`
`FILES_ONLY`
Instruction to display only files.
`static final String`
`MULTI_SELECTION_ENABLED_CHANGED_PROPERTY`
Enables multiple-file selections.
`static final int`
`OPEN_DIALOG`
Type value indicating that the `JFileChooser` supports an "Open" file operation.
`static final int`
`SAVE_DIALOG`
Type value indicating that the `JFileChooser` supports a "Save" file operation.
`static final String`
`SELECTED_FILE_CHANGED_PROPERTY`
Identifies change in user's single-file selection.
`static final String`
`SELECTED_FILES_CHANGED_PROPERTY`
Identifies change in user's multiple-file selection.

### Fields declared in class JComponent

`listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`
Modifier and Type
Field
Description
`protected EventListenerList`
`listenerList`
A list of event listeners for this component.
`static final String`
`TOOL_TIP_TEXT_KEY`
The comment to display when the cursor is over the component, also known as a "value tip", "flyover help", or "flyover label".
`protected ComponentUI`
`ui`
The look and feel delegate for this component.
`static final int`
`UNDEFINED_CONDITION`
Constant used by some of the APIs to mean that no condition is defined.
`static final int`
`WHEN_ANCESTOR_OF_FOCUSED_COMPONENT`
Constant used for `registerKeyboardAction` that means that the command should be invoked when the receiving component is an ancestor of the focused component or is itself the focused component.
`static final int`
`WHEN_FOCUSED`
Constant used for `registerKeyboardAction` that means that the command should be invoked when the component has the focus.
`static final int`
`WHEN_IN_FOCUSED_WINDOW`
Constant used for `registerKeyboardAction` that means that the command should be invoked when the receiving component is in the window that has the focus or is itself the focused component.

### Fields declared in class Component

`BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`
Modifier and Type
Field
Description
`static final float`
`BOTTOM_ALIGNMENT`
Ease-of-use constant for `getAlignmentY`.
`static final float`
`CENTER_ALIGNMENT`
Ease-of-use constant for `getAlignmentY` and `getAlignmentX`.
`static final float`
`LEFT_ALIGNMENT`
Ease-of-use constant for `getAlignmentX`.
`static final float`
`RIGHT_ALIGNMENT`
Ease-of-use constant for `getAlignmentX`.
`static final float`
`TOP_ALIGNMENT`
Ease-of-use constant for `getAlignmentY()`.

### Fields declared in interface ImageObserver

`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`
Modifier and Type
Field
Description
`static final int`
`ABORT`
This flag in the infoflags argument to imageUpdate indicates that an image which was being tracked asynchronously was aborted before production was complete.
`static final int`
`ALLBITS`
This flag in the infoflags argument to imageUpdate indicates that a static image which was previously drawn is now complete and can be drawn again in its final form.
`static final int`
`ERROR`
This flag in the infoflags argument to imageUpdate indicates that an image which was being tracked asynchronously has encountered an error.
`static final int`
`FRAMEBITS`
This flag in the infoflags argument to imageUpdate indicates that another complete frame of a multi-frame image which was previously drawn is now available to be drawn again.
`static final int`
`HEIGHT`
This flag in the infoflags argument to imageUpdate indicates that the height of the base image is now available and can be taken from the height argument to the imageUpdate callback method.
`static final int`
`PROPERTIES`
This flag in the infoflags argument to imageUpdate indicates that the properties of the image are now available.
`static final int`
`SOMEBITS`
This flag in the infoflags argument to imageUpdate indicates that more pixels needed for drawing a scaled variation of the image are available.
`static final int`
`WIDTH`
This flag in the infoflags argument to imageUpdate indicates that the width of the base image is now available and can be taken from the width argument to the imageUpdate callback method.

## Constructor Summary

Constructors
Constructor
Description
`JFileChooser()`
Constructs a `JFileChooser` pointing to the user's default directory.
`JFileChooser(File currentDirectory)`
Constructs a `JFileChooser` using the given `File` as the path.
`JFileChooser(File currentDirectory, FileSystemView fsv)`
Constructs a `JFileChooser` using the given current directory and `FileSystemView`.
`JFileChooser(String currentDirectoryPath)`
Constructs a `JFileChooser` using the given path.
`JFileChooser(String currentDirectoryPath, FileSystemView fsv)`
Constructs a `JFileChooser` using the given current directory path and `FileSystemView`.
`JFileChooser(FileSystemView fsv)`
Constructs a `JFileChooser` using the given `FileSystemView`.

## Method Summary

Modifier and Type
Method
Description
`boolean`
`accept(File f)`
Returns true if the file should be displayed.
`void`
`addActionListener(ActionListener l)`
Adds an `ActionListener` to the file chooser.
`void`
`addChoosableFileFilter(FileFilter filter)`
Adds a filter to the list of user choosable file filters.
`void`
`approveSelection()`
Called by the UI when the user hits the Approve button (labeled "Open" or "Save", by default).
`void`
`cancelSelection()`
Called by the UI when the user chooses the Cancel button.
`void`
`changeToParentDirectory()`
Changes the directory to be set to the parent of the current directory.
`protected JDialog`
`createDialog(Component parent)`
Creates and returns a new `JDialog` wrapping `this` centered on the `parent` in the `parent`'s frame.
`void`
`ensureFileIsVisible(File f)`
Makes sure that the specified file is viewable, and not hidden.
`protected void`
`fireActionPerformed(String command)`
Notifies all listeners that have registered interest for notification on this event type.
`FileFilter`
`getAcceptAllFileFilter()`
Returns the `AcceptAll` file filter.
`AccessibleContext`
`getAccessibleContext()`
Gets the AccessibleContext associated with this JFileChooser.
`JComponent`
`getAccessory()`
Returns the accessory component.
`ActionListener[]`
`getActionListeners()`
Returns an array of all the action listeners registered on this file chooser.
`int`
`getApproveButtonMnemonic()`
Returns the approve button's mnemonic.
`String`
`getApproveButtonText()`
Returns the text used in the `ApproveButton` in the `FileChooserUI`.
`String`
`getApproveButtonToolTipText()`
Returns the tooltip text used in the `ApproveButton`.
`FileFilter[]`
`getChoosableFileFilters()`
Gets the list of user choosable file filters.
`boolean`
`getControlButtonsAreShown()`
Returns the value of the `controlButtonsAreShown` property.
`File`
`getCurrentDirectory()`
Returns the current directory.
`String`
`getDescription(File f)`
Returns the file description.
`String`
`getDialogTitle()`
Gets the string that goes in the `JFileChooser`'s titlebar.
`int`
`getDialogType()`
Returns the type of this dialog.
`boolean`
`getDragEnabled()`
Gets the value of the `dragEnabled` property.
`FileFilter`
`getFileFilter()`
Returns the currently selected file filter.
`int`
`getFileSelectionMode()`
Returns the current file-selection mode.
`FileSystemView`
`getFileSystemView()`
Returns the file system view.
`FileView`
`getFileView()`
Returns the current file view.
`Icon`
`getIcon(File f)`
Returns the icon for this file or type of file, depending on the system.
`String`
`getName(File f)`
Returns the filename.
`File`
`getSelectedFile()`
Returns the selected file.
`File[]`
`getSelectedFiles()`
Returns a list of selected files if the file chooser is set to allow multiple selection.
`String`
`getTypeDescription(File f)`
Returns the file type.
`FileChooserUI`
`getUI()`
Gets the UI object which implements the L&F for this component.
`String`
`getUIClassID()`
Returns a string that specifies the name of the L&F class that renders this component.
`boolean`
`isAcceptAllFileFilterUsed()`
Returns whether the `AcceptAll FileFilter` is used.
`boolean`
`isDirectorySelectionEnabled()`
Convenience call that determines if directories are selectable based on the current file selection mode.
`boolean`
`isFileHidingEnabled()`
Returns true if hidden files are not shown in the file chooser; otherwise, returns false.
`boolean`
`isFileSelectionEnabled()`
Convenience call that determines if files are selectable based on the current file selection mode.
`boolean`
`isMultiSelectionEnabled()`
Returns true if multiple files can be selected.
`boolean`
`isTraversable(File f)`
Returns true if the file (directory) can be visited.
`protected String`
`paramString()`
Returns a string representation of this `JFileChooser`.
`void`
`removeActionListener(ActionListener l)`
Removes an `ActionListener` from the file chooser.
`boolean`
`removeChoosableFileFilter(FileFilter f)`
Removes a filter from the list of user choosable file filters.
`void`
`rescanCurrentDirectory()`
Tells the UI to rescan its files list from the current directory.
`void`
`resetChoosableFileFilters()`
Resets the choosable file filter list to its starting state.
`void`
`setAcceptAllFileFilterUsed(boolean b)`
Determines whether the `AcceptAll FileFilter` is used as an available choice in the choosable filter list.
`void`
`setAccessory(JComponent newAccessory)`
Sets the accessory component.
`void`
`setApproveButtonMnemonic(char mnemonic)`
Sets the approve button's mnemonic using a character.
`void`
`setApproveButtonMnemonic(int mnemonic)`
Sets the approve button's mnemonic using a numeric keycode.
`void`
`setApproveButtonText(String approveButtonText)`
Sets the text used in the `ApproveButton` in the `FileChooserUI`.
`void`
`setApproveButtonToolTipText(String toolTipText)`
Sets the tooltip text used in the `ApproveButton`.
`void`
`setControlButtonsAreShown(boolean b)`
Sets the property that indicates whether the approve and cancel buttons are shown in the file chooser.
`void`
`setCurrentDirectory(File dir)`
Sets the current directory.
`void`
`setDialogTitle(String dialogTitle)`
Sets the string that goes in the `JFileChooser` window's title bar.
`void`
`setDialogType(int dialogType)`
Sets the type of this dialog.
`void`
`setDragEnabled(boolean b)`
Sets the `dragEnabled` property, which must be `true` to enable automatic drag handling (the first part of drag and drop) on this component.
`void`
`setEnabled(boolean enabled)`
Sets whether or not this component is enabled.
`void`
`setFileFilter(FileFilter filter)`
Sets the current file filter.
`void`
`setFileHidingEnabled(boolean b)`
Sets file hiding on or off.
`void`
`setFileSelectionMode(int mode)`
Sets the `JFileChooser` to allow the user to just select files, just select directories, or select both files and directories.
`void`
`setFileSystemView(FileSystemView fsv)`
Sets the file system view that the `JFileChooser` uses for accessing and creating file system resources, such as finding the floppy drive and getting a list of root drives.
`void`
`setFileView(FileView fileView)`
Sets the file view to be used to retrieve UI information, such as the icon that represents a file or the type description of a file.
`void`
`setMultiSelectionEnabled(boolean b)`
Sets the file chooser to allow multiple file selections.
`void`
`setSelectedFile(File file)`
Sets the selected file.
`void`
`setSelectedFiles(File[] selectedFiles)`
Sets the list of selected files if the file chooser is set to allow multiple selection.
`protected void`
`setup(FileSystemView view)`
Performs common constructor initialization and setup.
`int`
`showDialog(Component parent, String approveButtonText)`
Pops a custom file chooser dialog with a custom approve button.
`int`
`showOpenDialog(Component parent)`
Pops up an "Open File" file chooser dialog.
`int`
`showSaveDialog(Component parent)`
Pops up a "Save File" file chooser dialog.
`void`
`updateUI()`
Resets the UI property to a value from the current look and feel.

### Methods declared in class JComponent

`addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, hide, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingOrigin, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`
Modifier and Type
Method
Description
`void`
`addAncestorListener(AncestorListener listener)`
Registers `listener` so that it will receive `AncestorEvents` when it or any of its ancestors move or are made visible or invisible.
`void`
`addNotify()`
Notifies this component that it now has a parent component.
`void`
`addVetoableChangeListener(VetoableChangeListener listener)`
Adds a `VetoableChangeListener` to the listener list.
`void`
`computeVisibleRect(Rectangle visibleRect)`
Returns the `Component`'s "visible rect rectangle" - the intersection of the visible rectangles for this component and all of its ancestors.
`boolean`
`contains(int x, int y)`
Gives the UI delegate an opportunity to define the precise shape of this component for the sake of mouse processing.
`JToolTip`
`createToolTip()`
Returns the instance of `JToolTip` that should be used to display the tooltip.
`void`
`disable()`
Deprecated.
As of JDK version 1.1, replaced by `java.awt.Component.setEnabled(boolean)`.
`void`
`enable()`
Deprecated.
As of JDK version 1.1, replaced by `java.awt.Component.setEnabled(boolean)`.
`void`
`firePropertyChange(String propertyName, boolean oldValue, boolean newValue)`
Support for reporting bound property changes for boolean properties.
`void`
`firePropertyChange(String propertyName, int oldValue, int newValue)`
Support for reporting bound property changes for integer properties.
`protected void`
`fireVetoableChange(String propertyName, Object oldValue, Object newValue)`
Supports reporting constrained property changes.
`ActionListener`
`getActionForKeyStroke(KeyStroke aKeyStroke)`
Returns the object that will perform the action registered for a given keystroke.
`final ActionMap`
`getActionMap()`
Returns the `ActionMap` used to determine what `Action` to fire for particular `KeyStroke` binding.
`float`
`getAlignmentX()`
Overrides `Container.getAlignmentX` to return the horizontal alignment.
`float`
`getAlignmentY()`
Overrides `Container.getAlignmentY` to return the vertical alignment.
`AncestorListener[]`
`getAncestorListeners()`
Returns an array of all the ancestor listeners registered on this component.
`boolean`
`getAutoscrolls()`
Gets the `autoscrolls` property.
`int`
`getBaseline(int width, int height)`
Returns the baseline.
`Component.BaselineResizeBehavior`
`getBaselineResizeBehavior()`
Returns an enum indicating how the baseline of the component changes as the size changes.
`Border`
`getBorder()`
Returns the border of this component or `null` if no border is currently set.
`Rectangle`
`getBounds(Rectangle rv)`
Stores the bounds of this component into "return value" `rv` and returns `rv`.
`final Object`
`getClientProperty(Object key)`
Returns the value of the property with the specified key.
`protected Graphics`
`getComponentGraphics(Graphics g)`
Returns the graphics object used to paint this component.
`JPopupMenu`
`getComponentPopupMenu()`
Returns `JPopupMenu` that assigned for this component.
`int`
`getConditionForKeyStroke(KeyStroke aKeyStroke)`
Returns the condition that determines whether a registered action occurs in response to the specified keystroke.
`int`
`getDebugGraphicsOptions()`
Returns the state of graphics debugging.
`static Locale`
`getDefaultLocale()`
Returns the default locale used to initialize each JComponent's locale property upon creation.
`FontMetrics`
`getFontMetrics(Font font)`
Gets the `FontMetrics` for the specified `Font`.
`Graphics`
`getGraphics()`
Returns this component's graphics context, which lets you draw on a component.
`int`
`getHeight()`
Returns the current height of this component.
`boolean`
`getInheritsPopupMenu()`
Returns true if the JPopupMenu should be inherited from the parent.
`final InputMap`
`getInputMap()`
Returns the `InputMap` that is used when the component has focus.
`final InputMap`
`getInputMap(int condition)`
Returns the `InputMap` that is used during `condition`.
`InputVerifier`
`getInputVerifier()`
Returns the input verifier for this component.
`Insets`
`getInsets()`
If a border has been set on this component, returns the border's insets; otherwise calls `super.getInsets`.
`Insets`
`getInsets(Insets insets)`
Returns an `Insets` object containing this component's inset values.
`<T extends EventListener>
T[]`
`getListeners(Class<T> listenerType)`
Returns an array of all the objects currently registered as `FooListener`s upon this `JComponent`.
`Point`
`getLocation(Point rv)`
Stores the x,y origin of this component into "return value" `rv` and returns `rv`.
`Dimension`
`getMaximumSize()`
If the maximum size has been set to a non-`null` value just returns it.
`Dimension`
`getMinimumSize()`
If the minimum size has been set to a non-`null` value just returns it.
`Component`
`getNextFocusableComponent()`
Deprecated.
As of 1.4, replaced by `FocusTraversalPolicy`.
`Point`
`getPopupLocation(MouseEvent event)`
Returns the preferred location to display the popup menu in this component's coordinate system.
`Dimension`
`getPreferredSize()`
If the `preferredSize` has been set to a non-`null` value just returns it.
`KeyStroke[]`
`getRegisteredKeyStrokes()`
Returns the `KeyStrokes` that will initiate registered actions.
`JRootPane`
`getRootPane()`
Returns the `JRootPane` ancestor for this component.
`Dimension`
`getSize(Dimension rv)`
Stores the width/height of this component into "return value" `rv` and returns `rv`.
`Point`
`getToolTipLocation(MouseEvent event)`
Returns the tooltip location in this component's coordinate system.
`String`
`getToolTipText()`
Returns the tooltip string that has been set with `setToolTipText`.
`String`
`getToolTipText(MouseEvent event)`
Returns the string to be used as the tooltip for event.
`Container`
`getTopLevelAncestor()`
Returns the top-level ancestor of this component (the containing `Window`) or `null` if this component has not been added to any container.
`TransferHandler`
`getTransferHandler()`
Gets the `transferHandler` property.
`boolean`
`getVerifyInputWhenFocusTarget()`
Returns the value that indicates whether the input verifier for the current focus owner will be called before this component requests focus.
`VetoableChangeListener[]`
`getVetoableChangeListeners()`
Returns an array of all the vetoable change listeners registered on this component.
`Rectangle`
`getVisibleRect()`
Returns the `Component`'s "visible rectangle" - the intersection of this component's visible rectangle, `new Rectangle(0, 0, getWidth(), getHeight())`, and all of its ancestors' visible rectangles.
`int`
`getWidth()`
Returns the current width of this component.
`int`
`getX()`
Returns the current x coordinate of the component's origin.
`int`
`getY()`
Returns the current y coordinate of the component's origin.
`void`
`grabFocus()`
Requests that this Component get the input focus, and that this Component's top-level ancestor become the focused Window.
`void`
`hide()`
Deprecated.
`boolean`
`isDoubleBuffered()`
Returns whether this component should use a buffer to paint.
`static boolean`
`isLightweightComponent(Component c)`
Returns true if this component is lightweight, that is, if it doesn't have a native window system peer.
`boolean`
`isManagingFocus()`
Deprecated.
As of 1.4, replaced by `Component.setFocusTraversalKeys(int, Set)` and `Container.setFocusCycleRoot(boolean)`.
`boolean`
`isOpaque()`
Returns true if this component is completely opaque.
`boolean`
`isOptimizedDrawingEnabled()`
Returns true if this component tiles its children -- that is, if it can guarantee that the children will not overlap.
`final boolean`
`isPaintingForPrint()`
Returns `true` if the current painting operation on this component is part of a `print` operation.
`protected boolean`
`isPaintingOrigin()`
Returns `true` if a paint triggered on a child component should cause painting to originate from this Component, or one of its ancestors.
`boolean`
`isPaintingTile()`
Returns true if the component is currently painting a tile.
`boolean`
`isRequestFocusEnabled()`
Returns `true` if this `JComponent` should get focus; otherwise returns `false`.
`boolean`
`isValidateRoot()`
If this method returns true, `revalidate` calls by descendants of this component will cause the entire tree beginning with this root to be validated.
`void`
`paint(Graphics g)`
Invoked by Swing to draw components.
`protected void`
`paintBorder(Graphics g)`
Paints the component's border.
`protected void`
`paintChildren(Graphics g)`
Paints this component's children.
`protected void`
`paintComponent(Graphics g)`
Calls the UI delegate's paint method, if the UI delegate is non-`null`.
`void`
`paintImmediately(int x, int y, int w, int h)`
Paints the specified region in this component and all of its descendants that overlap the region, immediately.
`void`
`paintImmediately(Rectangle r)`
Paints the specified region now.
`void`
`print(Graphics g)`
Invoke this method to print the component to the specified `Graphics`.
`void`
`printAll(Graphics g)`
Invoke this method to print the component.
`protected void`
`printBorder(Graphics g)`
Prints the component's border.
`protected void`
`printChildren(Graphics g)`
Prints this component's children.
`protected void`
`printComponent(Graphics g)`
This is invoked during a printing operation.
`protected void`
`processComponentKeyEvent(KeyEvent e)`
Processes any key events that the component itself recognizes.
`protected boolean`
`processKeyBinding(KeyStroke ks, KeyEvent e, int condition, boolean pressed)`
Invoked to process the key bindings for `ks` as the result of the `KeyEvent` `e`.
`protected void`
`processKeyEvent(KeyEvent e)`
Overrides `processKeyEvent` to process events.
`protected void`
`processMouseEvent(MouseEvent e)`
Processes mouse events occurring on this component by dispatching them to any registered `MouseListener` objects, refer to `Component.processMouseEvent(MouseEvent)` for a complete description of this method.
`protected void`
`processMouseMotionEvent(MouseEvent e)`
Processes mouse motion events, such as MouseEvent.MOUSE_DRAGGED.
`final void`
`putClientProperty(Object key, Object value)`
Adds an arbitrary key/value "client property" to this component.
`void`
`registerKeyboardAction(ActionListener anAction, String aCommand, KeyStroke aKeyStroke, int aCondition)`
This method is now obsolete, please use a combination of `getActionMap()` and `getInputMap()` for similar behavior.
`void`
`registerKeyboardAction(ActionListener anAction, KeyStroke aKeyStroke, int aCondition)`
This method is now obsolete, please use a combination of `getActionMap()` and `getInputMap()` for similar behavior.
`void`
`removeAncestorListener(AncestorListener listener)`
Unregisters `listener` so that it will no longer receive `AncestorEvents`.
`void`
`removeNotify()`
Notifies this component that it no longer has a parent component.
`void`
`removeVetoableChangeListener(VetoableChangeListener listener)`
Removes a `VetoableChangeListener` from the listener list.
`void`
`repaint(long tm, int x, int y, int width, int height)`
Adds the specified region to the dirty region list if the component is showing.
`void`
`repaint(Rectangle r)`
Adds the specified region to the dirty region list if the component is showing.
`boolean`
`requestDefaultFocus()`
Deprecated.
As of 1.4, replaced by `FocusTraversalPolicy.getDefaultComponent(Container).requestFocus()`
`void`
`requestFocus()`
Requests that this `Component` gets the input focus.
`boolean`
`requestFocus(boolean temporary)`
Requests that this `Component` gets the input focus.
`boolean`
`requestFocusInWindow()`
Requests that this `Component` gets the input focus.
`protected boolean`
`requestFocusInWindow(boolean temporary)`
Requests that this `Component` gets the input focus.
`void`
`resetKeyboardActions()`
Unregisters all the bindings in the first tier `InputMaps` and `ActionMap`.
`void`
`reshape(int x, int y, int w, int h)`
Deprecated.
As of JDK 5, replaced by `Component.setBounds(int, int, int, int)`.
`void`
`revalidate()`
Supports deferred automatic layout.
`void`
`scrollRectToVisible(Rectangle aRect)`
Forwards the `scrollRectToVisible()` message to the `JComponent`'s parent.
`final void`
`setActionMap(ActionMap am)`
Sets the `ActionMap` to `am`.
`void`
`setAlignmentX(float alignmentX)`
Sets the horizontal alignment.
`void`
`setAlignmentY(float alignmentY)`
Sets the vertical alignment.
`void`
`setAutoscrolls(boolean autoscrolls)`
Sets the `autoscrolls` property.
`void`
`setBackground(Color bg)`
Sets the background color of this component.
`void`
`setBorder(Border border)`
Sets the border of this component.
`void`
`setComponentPopupMenu(JPopupMenu popup)`
Sets the `JPopupMenu` for this `JComponent`.
`void`
`setDebugGraphicsOptions(int debugOptions)`
Enables or disables diagnostic information about every graphics operation performed within the component or one of its children.
`static void`
`setDefaultLocale(Locale l)`
Sets the default locale used to initialize each JComponent's locale property upon creation.
`void`
`setDoubleBuffered(boolean aFlag)`
Sets whether this component should use a buffer to paint.
`void`
`setFocusTraversalKeys(int id, Set<? extends AWTKeyStroke> keystrokes)`
Sets the focus traversal keys for a given traversal operation for this Component.
`void`
`setFont(Font font)`
Sets the font for this component.
`void`
`setForeground(Color fg)`
Sets the foreground color of this component.
`void`
`setInheritsPopupMenu(boolean value)`
Sets whether or not `getComponentPopupMenu` should delegate to the parent if this component does not have a `JPopupMenu` assigned to it.
`final void`
`setInputMap(int condition, InputMap map)`
Sets the `InputMap` to use under the condition `condition` to `map`.
`void`
`setInputVerifier(InputVerifier inputVerifier)`
Sets the input verifier for this component.
`void`
`setMaximumSize(Dimension maximumSize)`
Sets the maximum size of this component to a constant value.
`void`
`setMinimumSize(Dimension minimumSize)`
Sets the minimum size of this component to a constant value.
`void`
`setNextFocusableComponent(Component aComponent)`
Deprecated.
As of 1.4, replaced by `FocusTraversalPolicy`
`void`
`setOpaque(boolean isOpaque)`
If true the component paints every pixel within its bounds.
`void`
`setPreferredSize(Dimension preferredSize)`
Sets the preferred size of this component.
`void`
`setRequestFocusEnabled(boolean requestFocusEnabled)`
Provides a hint as to whether or not this `JComponent` should get focus.
`void`
`setToolTipText(String text)`
Registers the text to display in a tool tip.
`void`
`setTransferHandler(TransferHandler newHandler)`
Sets the `TransferHandler`, which provides support for transfer of data into and out of this component via cut/copy/paste and drag and drop.
`protected void`
`setUI(ComponentUI newUI)`
Sets the look and feel delegate for this component.
`void`
`setVerifyInputWhenFocusTarget(boolean verifyInputWhenFocusTarget)`
Sets the value to indicate whether input verifier for the current focus owner will be called before this component requests focus.
`void`
`setVisible(boolean aFlag)`
Makes the component visible or invisible.
`void`
`unregisterKeyboardAction(KeyStroke aKeyStroke)`
This method is now obsolete.
`void`
`update(Graphics g)`
Calls `paint`.

### Methods declared in class Container

`add, add, add, add, add, addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, validate, validateTree`
Modifier and Type
Method
Description
`Component`
`add(Component comp)`
Appends the specified component to the end of this container.
`Component`
`add(Component comp, int index)`
Adds the specified component to this container at the given position.
`void`
`add(Component comp, Object constraints)`
Adds the specified component to the end of this container.
`void`
`add(Component comp, Object constraints, int index)`
Adds the specified component to this container with the specified constraints at the specified index.
`Component`
`add(String name, Component comp)`
Adds the specified component to this container.
`void`
`addContainerListener(ContainerListener l)`
Adds the specified container listener to receive container events from this container.
`protected void`
`addImpl(Component comp, Object constraints, int index)`
Adds the specified component to this container at the specified index.
`void`
`addPropertyChangeListener(PropertyChangeListener listener)`
Adds a PropertyChangeListener to the listener list.
`void`
`addPropertyChangeListener(String propertyName, PropertyChangeListener listener)`
Adds a PropertyChangeListener to the listener list for a specific property.
`void`
`applyComponentOrientation(ComponentOrientation o)`
Sets the `ComponentOrientation` property of this container and all components contained within it.
`boolean`
`areFocusTraversalKeysSet(int id)`
Returns whether the Set of focus traversal keys for the given focus traversal operation has been explicitly defined for this Container.
`int`
`countComponents()`
Deprecated.
As of JDK version 1.1, replaced by getComponentCount().
`void`
`deliverEvent(Event e)`
Deprecated.
As of JDK version 1.1, replaced by `dispatchEvent(AWTEvent e)`
`void`
`doLayout()`
Causes this container to lay out its components.
`Component`
`findComponentAt(int x, int y)`
Locates the visible child component that contains the specified position.
`Component`
`findComponentAt(Point p)`
Locates the visible child component that contains the specified point.
`Component`
`getComponent(int n)`
Gets the nth component in this container.
`Component`
`getComponentAt(int x, int y)`
Locates the component that contains the x,y position.
`Component`
`getComponentAt(Point p)`
Gets the component that contains the specified point.
`int`
`getComponentCount()`
Gets the number of components in this panel.
`Component[]`
`getComponents()`
Gets all the components in this container.
`int`
`getComponentZOrder(Component comp)`
Returns the z-order index of the component inside the container.
`ContainerListener[]`
`getContainerListeners()`
Returns an array of all the container listeners registered on this container.
`Set<AWTKeyStroke>`
`getFocusTraversalKeys(int id)`
Returns the Set of focus traversal keys for a given traversal operation for this Container.
`FocusTraversalPolicy`
`getFocusTraversalPolicy()`
Returns the focus traversal policy that will manage keyboard traversal of this Container's children, or null if this Container is not a focus cycle root.
`LayoutManager`
`getLayout()`
Gets the layout manager for this container.
`Point`
`getMousePosition(boolean allowChildren)`
Returns the position of the mouse pointer in this `Container`'s coordinate space if the `Container` is under the mouse pointer, otherwise returns `null`.
`Insets`
`insets()`
Deprecated.
As of JDK version 1.1, replaced by `getInsets()`.
`void`
`invalidate()`
Invalidates the container.
`boolean`
`isAncestorOf(Component c)`
Checks if the component is contained in the component hierarchy of this container.
`boolean`
`isFocusCycleRoot()`
Returns whether this Container is the root of a focus traversal cycle.
`boolean`
`isFocusCycleRoot(Container container)`
Returns whether the specified Container is the focus cycle root of this Container's focus traversal cycle.
`final boolean`
`isFocusTraversalPolicyProvider()`
Returns whether this container provides focus traversal policy.
`boolean`
`isFocusTraversalPolicySet()`
Returns whether the focus traversal policy has been explicitly set for this Container.
`void`
`layout()`
Deprecated.
As of JDK version 1.1, replaced by `doLayout()`.
`void`
`list(PrintStream out, int indent)`
Prints a listing of this container to the specified output stream.
`void`
`list(PrintWriter out, int indent)`
Prints out a list, starting at the specified indentation, to the specified print writer.
`Component`
`locate(int x, int y)`
Deprecated.
As of JDK version 1.1, replaced by `getComponentAt(int, int)`.
`Dimension`
`minimumSize()`
Deprecated.
As of JDK version 1.1, replaced by `getMinimumSize()`.
`void`
`paintComponents(Graphics g)`
Paints each of the components in this container.
`Dimension`
`preferredSize()`
Deprecated.
As of JDK version 1.1, replaced by `getPreferredSize()`.
`void`
`printComponents(Graphics g)`
Prints each of the components in this container.
`protected void`
`processContainerEvent(ContainerEvent e)`
Processes container events occurring on this container by dispatching them to any registered ContainerListener objects.
`protected void`
`processEvent(AWTEvent e)`
Processes events on this container.
`void`
`remove(int index)`
Removes the component, specified by `index`, from this container.
`void`
`remove(Component comp)`
Removes the specified component from this container.
`void`
`removeAll()`
Removes all the components from this container.
`void`
`removeContainerListener(ContainerListener l)`
Removes the specified container listener so it no longer receives container events from this container.
`void`
`setComponentZOrder(Component comp, int index)`
Moves the specified component to the specified z-order index in the container.
`void`
`setFocusCycleRoot(boolean focusCycleRoot)`
Sets whether this Container is the root of a focus traversal cycle.
`void`
`setFocusTraversalPolicy(FocusTraversalPolicy policy)`
Sets the focus traversal policy that will manage keyboard traversal of this Container's children, if this Container is a focus cycle root.
`final void`
`setFocusTraversalPolicyProvider(boolean provider)`
Sets whether this container will be used to provide focus traversal policy.
`void`
`setLayout(LayoutManager mgr)`
Sets the layout manager for this container.
`void`
`transferFocusDownCycle()`
Transfers the focus down one focus traversal cycle.
`void`
`validate()`
Validates this container and all of its subcomponents.
`protected void`
`validateTree()`
Recursively descends the container tree and recomputes the layout for any subtrees marked as needing it (those marked as invalid).

### Methods declared in class Component

`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, requestFocus, requestFocus, requestFocusInWindow, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setMixingCutoutShape, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`
Modifier and Type
Method
Description
`boolean`
`action(Event evt, Object what)`
Deprecated.
As of JDK version 1.1, should register this component as ActionListener on component which fires action events.
`void`
`add(PopupMenu popup)`
Adds the specified popup menu to the component.
`void`
`addComponentListener(ComponentListener l)`
Adds the specified component listener to receive component events from this component.
`void`
`addFocusListener(FocusListener l)`
Adds the specified focus listener to receive focus events from this component when this component gains input focus.
`void`
`addHierarchyBoundsListener(HierarchyBoundsListener l)`
Adds the specified hierarchy bounds listener to receive hierarchy bounds events from this component when the hierarchy to which this container belongs changes.
`void`
`addHierarchyListener(HierarchyListener l)`
Adds the specified hierarchy listener to receive hierarchy changed events from this component when the hierarchy to which this container belongs changes.
`void`
`addInputMethodListener(InputMethodListener l)`
Adds the specified input method listener to receive input method events from this component.
`void`
`addKeyListener(KeyListener l)`
Adds the specified key listener to receive key events from this component.
`void`
`addMouseListener(MouseListener l)`
Adds the specified mouse listener to receive mouse events from this component.
`void`
`addMouseMotionListener(MouseMotionListener l)`
Adds the specified mouse motion listener to receive mouse motion events from this component.
`void`
`addMouseWheelListener(MouseWheelListener l)`
Adds the specified mouse wheel listener to receive mouse wheel events from this component.
`Rectangle`
`bounds()`
Deprecated.
As of JDK version 1.1, replaced by `getBounds()`.
`int`
`checkImage(Image image, int width, int height, ImageObserver observer)`
Returns the status of the construction of a screen representation of the specified image.
`int`
`checkImage(Image image, ImageObserver observer)`
Returns the status of the construction of a screen representation of the specified image.
`protected AWTEvent`
`coalesceEvents(AWTEvent existingEvent, AWTEvent newEvent)`
Potentially coalesce an event being posted with an existing event.
`boolean`
`contains(Point p)`
Checks whether this component "contains" the specified point, where the point's x and y coordinates are defined to be relative to the coordinate system of this component.
`Image`
`createImage(int width, int height)`
Creates an off-screen drawable image to be used for double buffering.
`Image`
`createImage(ImageProducer producer)`
Creates an image from the specified image producer.
`VolatileImage`
`createVolatileImage(int width, int height)`
Creates a volatile off-screen drawable image to be used for double buffering.
`VolatileImage`
`createVolatileImage(int width, int height, ImageCapabilities caps)`
Creates a volatile off-screen drawable image, with the given capabilities.
`protected final void`
`disableEvents(long eventsToDisable)`
Disables the events defined by the specified event mask parameter from being delivered to this component.
`final void`
`dispatchEvent(AWTEvent e)`
Dispatches an event to this component or one of its sub components.
`void`
`enable(boolean b)`
Deprecated.
As of JDK version 1.1, replaced by `setEnabled(boolean)`.
`protected final void`
`enableEvents(long eventsToEnable)`
Enables the events defined by the specified event mask parameter to be delivered to this component.
`void`
`enableInputMethods(boolean enable)`
Enables or disables input method support for this component.
`void`
`firePropertyChange(String propertyName, byte oldValue, byte newValue)`
Reports a bound property change.
`void`
`firePropertyChange(String propertyName, char oldValue, char newValue)`
Reports a bound property change.
`void`
`firePropertyChange(String propertyName, double oldValue, double newValue)`
Reports a bound property change.
`void`
`firePropertyChange(String propertyName, float oldValue, float newValue)`
Reports a bound property change.
`void`
`firePropertyChange(String propertyName, long oldValue, long newValue)`
Reports a bound property change.
`void`
`firePropertyChange(String propertyName, short oldValue, short newValue)`
Reports a bound property change.
`protected void`
`firePropertyChange(String propertyName, Object oldValue, Object newValue)`
Support for reporting bound property changes for Object properties.
`Color`
`getBackground()`
Gets the background color of this component.
`Rectangle`
`getBounds()`
Gets the bounds of this component in the form of a `Rectangle` object.
`ColorModel`
`getColorModel()`
Gets the instance of `ColorModel` used to display the component on the output device.
`ComponentListener[]`
`getComponentListeners()`
Returns an array of all the component listeners registered on this component.
`ComponentOrientation`
`getComponentOrientation()`
Retrieves the language-sensitive orientation that is to be used to order the elements or text within this component.
`Cursor`
`getCursor()`
Gets the cursor set in the component.
`DropTarget`
`getDropTarget()`
Gets the `DropTarget` associated with this `Component`.
`Container`
`getFocusCycleRootAncestor()`
Returns the Container which is the focus cycle root of this Component's focus traversal cycle.
`FocusListener[]`
`getFocusListeners()`
Returns an array of all the focus listeners registered on this component.
`boolean`
`getFocusTraversalKeysEnabled()`
Returns whether focus traversal keys are enabled for this Component.
`Font`
`getFont()`
Gets the font of this component.
`Color`
`getForeground()`
Gets the foreground color of this component.
`GraphicsConfiguration`
`getGraphicsConfiguration()`
Gets the `GraphicsConfiguration` associated with this `Component`.
`HierarchyBoundsListener[]`
`getHierarchyBoundsListeners()`
Returns an array of all the hierarchy bounds listeners registered on this component.
`HierarchyListener[]`
`getHierarchyListeners()`
Returns an array of all the hierarchy listeners registered on this component.
`boolean`
`getIgnoreRepaint()`
Returns whether or not paint messages received from the operating system should be ignored.
`InputContext`
`getInputContext()`
Gets the input context used by this component for handling the communication with input methods when text is entered in this component.
`InputMethodListener[]`
`getInputMethodListeners()`
Returns an array of all the input method listeners registered on this component.
`InputMethodRequests`
`getInputMethodRequests()`
Gets the input method request handler which supports requests from input methods for this component.
`KeyListener[]`
`getKeyListeners()`
Returns an array of all the key listeners registered on this component.
`Locale`
`getLocale()`
Gets the locale of this component.
`Point`
`getLocation()`
Gets the location of this component in the form of a point specifying the component's top-left corner.
`Point`
`getLocationOnScreen()`
Gets the location of this component in the form of a point specifying the component's top-left corner in the screen's coordinate space.
`MouseListener[]`
`getMouseListeners()`
Returns an array of all the mouse listeners registered on this component.
`MouseMotionListener[]`
`getMouseMotionListeners()`
Returns an array of all the mouse motion listeners registered on this component.
`Point`
`getMousePosition()`
Returns the position of the mouse pointer in this `Component`'s coordinate space if the `Component` is directly under the mouse pointer, otherwise returns `null`.
`MouseWheelListener[]`
`getMouseWheelListeners()`
Returns an array of all the mouse wheel listeners registered on this component.
`String`
`getName()`
Gets the name of the component.
`Container`
`getParent()`
Gets the parent of this component.
`PropertyChangeListener[]`
`getPropertyChangeListeners()`
Returns an array of all the property change listeners registered on this component.
`PropertyChangeListener[]`
`getPropertyChangeListeners(String propertyName)`
Returns an array of all the listeners which have been associated with the named property.
`Dimension`
`getSize()`
Returns the size of this component in the form of a `Dimension` object.
`Toolkit`
`getToolkit()`
Gets the toolkit of this component.
`final Object`
`getTreeLock()`
Gets this component's locking object (the object that owns the thread synchronization monitor) for AWT component-tree and layout operations.
`boolean`
`gotFocus(Event evt, Object what)`
Deprecated.
As of JDK version 1.1, replaced by processFocusEvent(FocusEvent).
`boolean`
`handleEvent(Event evt)`
Deprecated.
As of JDK version 1.1 replaced by processEvent(AWTEvent).
`boolean`
`hasFocus()`
Returns `true` if this `Component` is the focus owner.
`boolean`
`imageUpdate(Image img, int infoflags, int x, int y, int w, int h)`
Repaints the component when the image has changed.
`boolean`
`inside(int x, int y)`
Deprecated.
As of JDK version 1.1, replaced by contains(int, int).
`boolean`
`isBackgroundSet()`
Returns whether the background color has been explicitly set for this Component.
`boolean`
`isCursorSet()`
Returns whether the cursor has been explicitly set for this Component.
`boolean`
`isDisplayable()`
Determines whether this component is displayable.
`boolean`
`isEnabled()`
Determines whether this component is enabled.
`boolean`
`isFocusable()`
Returns whether this Component can be focused.
`boolean`
`isFocusOwner()`
Returns `true` if this `Component` is the focus owner.
`boolean`
`isFocusTraversable()`
Deprecated.
As of 1.4, replaced by `isFocusable()`.
`boolean`
`isFontSet()`
Returns whether the font has been explicitly set for this Component.
`boolean`
`isForegroundSet()`
Returns whether the foreground color has been explicitly set for this Component.
`boolean`
`isLightweight()`
A lightweight component doesn't have a native toolkit peer.
`boolean`
`isMaximumSizeSet()`
Returns true if the maximum size has been set to a non-`null` value otherwise returns false.
`boolean`
`isMinimumSizeSet()`
Returns whether or not `setMinimumSize` has been invoked with a non-null value.
`boolean`
`isPreferredSizeSet()`
Returns true if the preferred size has been set to a non-`null` value otherwise returns false.
`boolean`
`isShowing()`
Determines whether this component is showing on screen.
`boolean`
`isValid()`
Determines whether this component is valid.
`boolean`
`isVisible()`
Determines whether this component should be visible when its parent is visible.
`boolean`
`keyDown(Event evt, int key)`
Deprecated.
As of JDK version 1.1, replaced by processKeyEvent(KeyEvent).
`boolean`
`keyUp(Event evt, int key)`
Deprecated.
As of JDK version 1.1, replaced by processKeyEvent(KeyEvent).
`void`
`list()`
Prints a listing of this component to the standard system output stream `System.out`.
`void`
`list(PrintStream out)`
Prints a listing of this component to the specified output stream.
`void`
`list(PrintWriter out)`
Prints a listing to the specified print writer.
`Point`
`location()`
Deprecated.
As of JDK version 1.1, replaced by `getLocation()`.
`boolean`
`lostFocus(Event evt, Object what)`
Deprecated.
As of JDK version 1.1, replaced by processFocusEvent(FocusEvent).
`boolean`
`mouseDown(Event evt, int x, int y)`
Deprecated.
As of JDK version 1.1, replaced by processMouseEvent(MouseEvent).
`boolean`
`mouseDrag(Event evt, int x, int y)`
Deprecated.
As of JDK version 1.1, replaced by processMouseMotionEvent(MouseEvent).
`boolean`
`mouseEnter(Event evt, int x, int y)`
Deprecated.
As of JDK version 1.1, replaced by processMouseEvent(MouseEvent).
`boolean`
`mouseExit(Event evt, int x, int y)`
Deprecated.
As of JDK version 1.1, replaced by processMouseEvent(MouseEvent).
`boolean`
`mouseMove(Event evt, int x, int y)`
Deprecated.
As of JDK version 1.1, replaced by processMouseMotionEvent(MouseEvent).
`boolean`
`mouseUp(Event evt, int x, int y)`
Deprecated.
As of JDK version 1.1, replaced by processMouseEvent(MouseEvent).
`void`
`move(int x, int y)`
Deprecated.
As of JDK version 1.1, replaced by `setLocation(int, int)`.
`void`
`nextFocus()`
Deprecated.
As of JDK version 1.1, replaced by transferFocus().
`void`
`paintAll(Graphics g)`
Paints this component and all of its subcomponents.
`boolean`
`postEvent(Event e)`
Deprecated.
As of JDK version 1.1, replaced by dispatchEvent(AWTEvent).
`boolean`
`prepareImage(Image image, int width, int height, ImageObserver observer)`
Prepares an image for rendering on this component at the specified width and height.
`boolean`
`prepareImage(Image image, ImageObserver observer)`
Prepares an image for rendering on this component.
`protected void`
`processComponentEvent(ComponentEvent e)`
Processes component events occurring on this component by dispatching them to any registered `ComponentListener` objects.
`protected void`
`processFocusEvent(FocusEvent e)`
Processes focus events occurring on this component by dispatching them to any registered `FocusListener` objects.
`protected void`
`processHierarchyBoundsEvent(HierarchyEvent e)`
Processes hierarchy bounds events occurring on this component by dispatching them to any registered `HierarchyBoundsListener` objects.
`protected void`
`processHierarchyEvent(HierarchyEvent e)`
Processes hierarchy events occurring on this component by dispatching them to any registered `HierarchyListener` objects.
`protected void`
`processInputMethodEvent(InputMethodEvent e)`
Processes input method events occurring on this component by dispatching them to any registered `InputMethodListener` objects.
`protected void`
`processMouseWheelEvent(MouseWheelEvent e)`
Processes mouse wheel events occurring on this component by dispatching them to any registered `MouseWheelListener` objects.
`void`
`remove(MenuComponent popup)`
Removes the specified popup menu from the component.
`void`
`removeComponentListener(ComponentListener l)`
Removes the specified component listener so that it no longer receives component events from this component.
`void`
`removeFocusListener(FocusListener l)`
Removes the specified focus listener so that it no longer receives focus events from this component.
`void`
`removeHierarchyBoundsListener(HierarchyBoundsListener l)`
Removes the specified hierarchy bounds listener so that it no longer receives hierarchy bounds events from this component.
`void`
`removeHierarchyListener(HierarchyListener l)`
Removes the specified hierarchy listener so that it no longer receives hierarchy changed events from this component.
`void`
`removeInputMethodListener(InputMethodListener l)`
Removes the specified input method listener so that it no longer receives input method events from this component.
`void`
`removeKeyListener(KeyListener l)`
Removes the specified key listener so that it no longer receives key events from this component.
`void`
`removeMouseListener(MouseListener l)`
Removes the specified mouse listener so that it no longer receives mouse events from this component.
`void`
`removeMouseMotionListener(MouseMotionListener l)`
Removes the specified mouse motion listener so that it no longer receives mouse motion events from this component.
`void`
`removeMouseWheelListener(MouseWheelListener l)`
Removes the specified mouse wheel listener so that it no longer receives mouse wheel events from this component.
`void`
`removePropertyChangeListener(PropertyChangeListener listener)`
Removes a PropertyChangeListener from the listener list.
`void`
`removePropertyChangeListener(String propertyName, PropertyChangeListener listener)`
Removes a `PropertyChangeListener` from the listener list for a specific property.
`void`
`repaint()`
Repaints this component.
`void`
`repaint(int x, int y, int width, int height)`
Repaints the specified rectangle of this component.
`void`
`repaint(long tm)`
Repaints the component.
`protected boolean`
`requestFocus(boolean temporary, FocusEvent.Cause cause)`
Requests by the reason of `cause` that this `Component` get the input focus, and that this `Component`'s top-level ancestor become the focused `Window`.
`void`
`requestFocus(FocusEvent.Cause cause)`
Requests by the reason of `cause` that this Component get the input focus, and that this Component's top-level ancestor become the focused Window.
`boolean`
`requestFocusInWindow(FocusEvent.Cause cause)`
Requests by the reason of `cause` that this Component get the input focus, if this Component's top-level ancestor is already the focused Window.
`void`
`resize(int width, int height)`
Deprecated.
As of JDK version 1.1, replaced by `setSize(int, int)`.
`void`
`resize(Dimension d)`
Deprecated.
As of JDK version 1.1, replaced by `setSize(Dimension)`.
`void`
`setBounds(int x, int y, int width, int height)`
Moves and resizes this component.
`void`
`setBounds(Rectangle r)`
Moves and resizes this component to conform to the new bounding rectangle `r`.
`void`
`setComponentOrientation(ComponentOrientation o)`
Sets the language-sensitive orientation that is to be used to order the elements or text within this component.
`void`
`setCursor(Cursor cursor)`
Sets the cursor image to the specified cursor.
`void`
`setDropTarget(DropTarget dt)`
Associate a `DropTarget` with this component.
`void`
`setFocusable(boolean focusable)`
Sets the focusable state of this Component to the specified value.
`void`
`setFocusTraversalKeysEnabled(boolean focusTraversalKeysEnabled)`
Sets whether focus traversal keys are enabled for this Component.
`void`
`setIgnoreRepaint(boolean ignoreRepaint)`
Sets whether or not paint messages received from the operating system should be ignored.
`void`
`setLocale(Locale l)`
Sets the locale of this component.
`void`
`setLocation(int x, int y)`
Moves this component to a new location.
`void`
`setLocation(Point p)`
Moves this component to a new location.
`void`
`setMixingCutoutShape(Shape shape)`
Sets a 'mixing-cutout' shape for this lightweight component.
`void`
`setName(String name)`
Sets the name of the component to the specified string.
`void`
`setSize(int width, int height)`
Resizes this component so that it has width `width` and height `height`.
`void`
`setSize(Dimension d)`
Resizes this component so that it has width `d.width` and height `d.height`.
`void`
`show()`
Deprecated.
As of JDK version 1.1, replaced by `setVisible(boolean)`.
`void`
`show(boolean b)`
Deprecated.
As of JDK version 1.1, replaced by `setVisible(boolean)`.
`Dimension`
`size()`
Deprecated.
As of JDK version 1.1, replaced by `getSize()`.
`String`
`toString()`
Returns a string representation of this component and its values.
`void`
`transferFocus()`
Transfers the focus to the next component, as though this Component were the focus owner.
`void`
`transferFocusBackward()`
Transfers the focus to the previous component, as though this Component were the focus owner.
`void`
`transferFocusUpCycle()`
Transfers the focus up one focus traversal cycle.

### Methods declared in class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`
Modifier and Type
Method
Description
`protected Object`
`clone()`
Creates and returns a copy of this object.
`boolean`
`equals(Object obj)`
Indicates whether some other object is "equal to" this one.
`protected void`
`finalize()`
Deprecated, for removal: This API element is subject to removal in a future version.
Finalization is deprecated and subject to removal in a future release.
`final Class<?>`
`getClass()`
Returns the runtime class of this `Object`.
`int`
`hashCode()`
Returns a hash code value for this object.
`final void`
`notify()`
Wakes up a single thread that is waiting on this object's monitor.
`final void`
`notifyAll()`
Wakes up all threads that are waiting on this object's monitor.
`final void`
`wait()`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
`final void`
`wait(long timeoutMillis)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
`final void`
`wait(long timeoutMillis, int nanos)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

## Field Details

### OPEN_DIALOG

public static final int OPEN_DIALOG
Type value indicating that the `JFileChooser` supports an "Open" file operation.

See Also:
  - Constant Field Values

### SAVE_DIALOG

public static final int SAVE_DIALOG
Type value indicating that the `JFileChooser` supports a "Save" file operation.

See Also:
  - Constant Field Values

### CUSTOM_DIALOG

public static final int CUSTOM_DIALOG
Type value indicating that the `JFileChooser` supports a developer-specified file operation.

See Also:
  - Constant Field Values

### CANCEL_OPTION

public static final int CANCEL_OPTION
Return value if cancel is chosen.

See Also:
  - Constant Field Values

### APPROVE_OPTION

public static final int APPROVE_OPTION
Return value if approve (yes, ok) is chosen.

See Also:
  - Constant Field Values

### ERROR_OPTION

public static final int ERROR_OPTION
Return value if an error occurred.

See Also:
  - Constant Field Values

### FILES_ONLY

public static final int FILES_ONLY
Instruction to display only files.

See Also:
  - Constant Field Values

### DIRECTORIES_ONLY

public static final int DIRECTORIES_ONLY
Instruction to display only directories.

See Also:
  - Constant Field Values

### FILES_AND_DIRECTORIES

public static final int FILES_AND_DIRECTORIES
Instruction to display both files and directories.

See Also:
  - Constant Field Values

### CANCEL_SELECTION

public static final String CANCEL_SELECTION
Instruction to cancel the current selection.

See Also:
  - Constant Field Values

### APPROVE_SELECTION

public static final String APPROVE_SELECTION
Instruction to approve the current selection (same as pressing yes or ok).

See Also:
  - Constant Field Values

### APPROVE_BUTTON_TEXT_CHANGED_PROPERTY

public static final String APPROVE_BUTTON_TEXT_CHANGED_PROPERTY
Identifies change in the text on the approve (yes, ok) button.

See Also:
  - Constant Field Values

### APPROVE_BUTTON_TOOL_TIP_TEXT_CHANGED_PROPERTY

public static final String APPROVE_BUTTON_TOOL_TIP_TEXT_CHANGED_PROPERTY
Identifies change in the tooltip text for the approve (yes, ok) button.

See Also:
  - Constant Field Values

### APPROVE_BUTTON_MNEMONIC_CHANGED_PROPERTY

public static final String APPROVE_BUTTON_MNEMONIC_CHANGED_PROPERTY
Identifies change in the mnemonic for the approve (yes, ok) button.

See Also:
  - Constant Field Values

### CONTROL_BUTTONS_ARE_SHOWN_CHANGED_PROPERTY

public static final String CONTROL_BUTTONS_ARE_SHOWN_CHANGED_PROPERTY
Instruction to display the control buttons.

See Also:
  - Constant Field Values

### DIRECTORY_CHANGED_PROPERTY

public static final String DIRECTORY_CHANGED_PROPERTY
Identifies user's directory change.

See Also:
  - Constant Field Values

### SELECTED_FILE_CHANGED_PROPERTY

public static final String SELECTED_FILE_CHANGED_PROPERTY
Identifies change in user's single-file selection.

See Also:
  - Constant Field Values

### SELECTED_FILES_CHANGED_PROPERTY

public static final String SELECTED_FILES_CHANGED_PROPERTY
Identifies change in user's multiple-file selection.

See Also:
  - Constant Field Values

### MULTI_SELECTION_ENABLED_CHANGED_PROPERTY

public static final String MULTI_SELECTION_ENABLED_CHANGED_PROPERTY
Enables multiple-file selections.

See Also:
  - Constant Field Values

### FILE_SYSTEM_VIEW_CHANGED_PROPERTY

public static final String FILE_SYSTEM_VIEW_CHANGED_PROPERTY
Says that a different object is being used to find available drives on the system.

See Also:
  - Constant Field Values

### FILE_VIEW_CHANGED_PROPERTY

public static final String FILE_VIEW_CHANGED_PROPERTY
Says that a different object is being used to retrieve file information.

See Also:
  - Constant Field Values

### FILE_HIDING_CHANGED_PROPERTY

public static final String FILE_HIDING_CHANGED_PROPERTY
Identifies a change in the display-hidden-files property.

See Also:
  - Constant Field Values

### FILE_FILTER_CHANGED_PROPERTY

public static final String FILE_FILTER_CHANGED_PROPERTY
User changed the kind of files to display.

See Also:
  - Constant Field Values

### FILE_SELECTION_MODE_CHANGED_PROPERTY

public static final String FILE_SELECTION_MODE_CHANGED_PROPERTY
Identifies a change in the kind of selection (single, multiple, etc.).

See Also:
  - Constant Field Values

### ACCESSORY_CHANGED_PROPERTY

public static final String ACCESSORY_CHANGED_PROPERTY
Says that a different accessory component is in use (for example, to preview files).

See Also:
  - Constant Field Values

### ACCEPT_ALL_FILE_FILTER_USED_CHANGED_PROPERTY

public static final String ACCEPT_ALL_FILE_FILTER_USED_CHANGED_PROPERTY
Identifies whether the AcceptAllFileFilter is used or not.

See Also:
  - Constant Field Values

### DIALOG_TITLE_CHANGED_PROPERTY

public static final String DIALOG_TITLE_CHANGED_PROPERTY
Identifies a change in the dialog title.

See Also:
  - Constant Field Values

### DIALOG_TYPE_CHANGED_PROPERTY

public static final String DIALOG_TYPE_CHANGED_PROPERTY
Identifies a change in the type of files displayed (files only, directories only, or both files and directories).

See Also:
  - Constant Field Values

### CHOOSABLE_FILE_FILTER_CHANGED_PROPERTY

public static final String CHOOSABLE_FILE_FILTER_CHANGED_PROPERTY
Identifies a change in the list of predefined file filters the user can choose from.

See Also:
  - Constant Field Values

### accessibleContext

protected AccessibleContext accessibleContext
`AccessibleContext` associated with this `JFileChooser`

## Constructor Details

### JFileChooser

public JFileChooser()
Constructs a `JFileChooser` pointing to the user's default directory. This default depends on the operating system. It is typically the "Documents" folder on Windows, and the user's home directory on Unix.

### JFileChooser

public JFileChooser(String currentDirectoryPath)
Constructs a `JFileChooser` using the given path. Passing in a `null` string causes the file chooser to point to the user's default directory. This default depends on the operating system. It is typically the "Documents" folder on Windows, and the user's home directory on Unix.

Parameters:
  `currentDirectoryPath` - a `String` giving the path to a file or directory

### JFileChooser

public JFileChooser(File currentDirectory)
Constructs a `JFileChooser` using the given `File` as the path. Passing in a `null` file causes the file chooser to point to the user's default directory. This default depends on the operating system. It is typically the "Documents" folder on Windows, and the user's home directory on Unix.

Parameters:
  `currentDirectory` - a `File` object specifying the path to a file or directory

### JFileChooser

public JFileChooser(FileSystemView fsv)
Constructs a `JFileChooser` using the given `FileSystemView`.

Parameters:
  `fsv` - a `FileSystemView`

### JFileChooser

public JFileChooser(File currentDirectory, FileSystemView fsv)
Constructs a `JFileChooser` using the given current directory and `FileSystemView`.

Parameters:
  `currentDirectory` - a `File` object specifying the path to a file or directory
  `fsv` - a `FileSystemView`

### JFileChooser

public JFileChooser(String currentDirectoryPath, FileSystemView fsv)
Constructs a `JFileChooser` using the given current directory path and `FileSystemView`.

Parameters:
  `currentDirectoryPath` - a `String` specifying the path to a file or directory
  `fsv` - a `FileSystemView`

## Method Details

### setup

protected void setup(FileSystemView view)
Performs common constructor initialization and setup.

Parameters:
  `view` - the `FileSystemView` used for setup

### setDragEnabled

@BeanProperty(bound=false, description="determines whether automatic drag handling is enabled") public void setDragEnabled(boolean b)
Sets the `dragEnabled` property, which must be `true` to enable automatic drag handling (the first part of drag and drop) on this component. The `transferHandler` property needs to be set to a non-`null` value for the drag to do anything. The default value of the `dragEnabled` property is `false`.

When automatic drag handling is enabled, most look and feels begin a drag-and-drop operation whenever the user presses the mouse button over an item and then moves the mouse a few pixels. Setting this property to `true` can therefore have a subtle effect on how selections behave.

Some look and feels might not support automatic drag and drop; they will ignore this property. You can work around such look and feels by modifying the component to directly call the `exportAsDrag` method of a `TransferHandler`.

Parameters:
  `b` - the value to set the `dragEnabled` property to
Throws:
  `HeadlessException` - if `b` is `true` and `GraphicsEnvironment.isHeadless()` returns `true`
Since:
  1.4
See Also:
  - `GraphicsEnvironment.isHeadless()`
  - `getDragEnabled()`
  - `JComponent.setTransferHandler(TransferHandler)`
  - `TransferHandler`

### getDragEnabled

public boolean getDragEnabled()
Gets the value of the `dragEnabled` property.

Returns:
  the value of the `dragEnabled` property
Since:
  1.4
See Also:
  - `setDragEnabled(boolean)`

### getSelectedFile

public File getSelectedFile()
Returns the selected file. This can be set either by the programmer via `setSelectedFile` or by a user action, such as either typing the filename into the UI or selecting the file from a list in the UI.

Returns:
  the selected file
See Also:
  - `setSelectedFile(File)`

### setSelectedFile

@BeanProperty(preferred=true) public void setSelectedFile(File file)
Sets the selected file. If the file's parent directory is not the current directory, changes the current directory to be the file's parent directory.

Parameters:
  `file` - the selected file
See Also:
  - `getSelectedFile()`

### getSelectedFiles

public File[] getSelectedFiles()
Returns a list of selected files if the file chooser is set to allow multiple selection.

Returns:
  an array of selected `File`s

### setSelectedFiles

@BeanProperty(description="The list of selected files if the chooser is in multiple selection mode.") public void setSelectedFiles(File[] selectedFiles)
Sets the list of selected files if the file chooser is set to allow multiple selection.

Parameters:
  `selectedFiles` - an array `File`s to be selected

### getCurrentDirectory

public File getCurrentDirectory()
Returns the current directory.

Returns:
  the current directory
See Also:
  - `setCurrentDirectory(File)`

### setCurrentDirectory

@BeanProperty(preferred=true, description="The directory that the JFileChooser is showing files of.") public void setCurrentDirectory(File dir)
Sets the current directory. Passing in `null` sets the file chooser to point to the user's default directory. This default depends on the operating system. It is typically the "Documents" folder on Windows, and the user's home directory on Unix. If the file passed in as `currentDirectory` is not a directory, the parent of the file will be used as the currentDirectory. If the parent is not traversable, then it will walk up the parent tree until it finds a traversable directory, or hits the root of the file system.

Parameters:
  `dir` - the current directory to point to
See Also:
  - `getCurrentDirectory()`

### changeToParentDirectory

public void changeToParentDirectory()
Changes the directory to be set to the parent of the current directory.

See Also:
  - `getCurrentDirectory()`

### rescanCurrentDirectory

public void rescanCurrentDirectory()
Tells the UI to rescan its files list from the current directory.

### ensureFileIsVisible

public void ensureFileIsVisible(File f)
Makes sure that the specified file is viewable, and not hidden.

Parameters:
  `f` - a File object

### showOpenDialog

public int showOpenDialog(Component parent) throws HeadlessException
Pops up an "Open File" file chooser dialog. Note that the text that appears in the approve button is determined by the L&F.

Parameters:
  `parent` - the parent component of the dialog, can be `null`; see `showDialog` for details
Returns:
  the return state of the file chooser on popdown:
  - JFileChooser.CANCEL_OPTION
  - JFileChooser.APPROVE_OPTION
  - JFileChooser.ERROR_OPTION if an error occurs or the dialog is dismissed
Throws:
  `HeadlessException` - if GraphicsEnvironment.isHeadless() returns true.
See Also:
  - `GraphicsEnvironment.isHeadless()`
  - `showDialog(Component, String)`

### showSaveDialog

public int showSaveDialog(Component parent) throws HeadlessException
Pops up a "Save File" file chooser dialog. Note that the text that appears in the approve button is determined by the L&F.

Parameters:
  `parent` - the parent component of the dialog, can be `null`; see `showDialog` for details
Returns:
  the return state of the file chooser on popdown:
  - JFileChooser.CANCEL_OPTION
  - JFileChooser.APPROVE_OPTION
  - JFileChooser.ERROR_OPTION if an error occurs or the dialog is dismissed
Throws:
  `HeadlessException` - if GraphicsEnvironment.isHeadless() returns true.
See Also:
  - `GraphicsEnvironment.isHeadless()`
  - `showDialog(Component, String)`

### showDialog

public int showDialog(Component parent, String approveButtonText) throws HeadlessException
Pops a custom file chooser dialog with a custom approve button. For example, the following code pops up a file chooser with a "Run Application" button (instead of the normal "Save" or "Open" button):

    filechooser.showDialog(parentFrame, "Run Application");

Alternatively, the following code does the same thing:

       JFileChooser chooser = new JFileChooser(null);
       chooser.setApproveButtonText("Run Application");
       chooser.showDialog(parentFrame, null);

The `parent` argument determines two things: the frame on which the open dialog depends and the component whose position the look and feel should consider when placing the dialog. If the parent is a `Frame` object (such as a `JFrame`) then the dialog depends on the frame and the look and feel positions the dialog relative to the frame (for example, centered over the frame). If the parent is a component, then the dialog depends on the frame containing the component, and is positioned relative to the component (for example, centered over the component). If the parent is `null`, then the dialog depends on no visible window, and it's placed in a look-and-feel-dependent position such as the center of the screen.

Parameters:
  `parent` - the parent component of the dialog; can be `null`
  `approveButtonText` - the text of the `ApproveButton`
Returns:
  the return state of the file chooser on popdown:
  - JFileChooser.CANCEL_OPTION
  - JFileChooser.APPROVE_OPTION
  - JFileChooser.ERROR_OPTION if an error occurs or the dialog is dismissed
Throws:
  `HeadlessException` - if GraphicsEnvironment.isHeadless() returns true.
See Also:
  - `GraphicsEnvironment.isHeadless()`

### createDialog

protected JDialog createDialog(Component parent) throws HeadlessException
Creates and returns a new `JDialog` wrapping `this` centered on the `parent` in the `parent`'s frame. This method can be overridden to further manipulate the dialog, to disable resizing, set the location, etc. Example:

        class MyFileChooser extends JFileChooser {
            protected JDialog createDialog(Component parent) throws HeadlessException {
                JDialog dialog = super.createDialog(parent);
                dialog.setLocation(300, 200);
                dialog.setResizable(false);
                return dialog;
            }
        }

Parameters:
  `parent` - the parent component of the dialog; can be `null`
Returns:
  a new `JDialog` containing this instance
Throws:
  `HeadlessException` - if GraphicsEnvironment.isHeadless() returns true.
Since:
  1.4
See Also:
  - `GraphicsEnvironment.isHeadless()`

### getControlButtonsAreShown

public boolean getControlButtonsAreShown()
Returns the value of the `controlButtonsAreShown` property.

Returns:
  the value of the `controlButtonsAreShown` property
Since:
  1.3
See Also:
  - `setControlButtonsAreShown(boolean)`

### setControlButtonsAreShown

@BeanProperty(preferred=true, description="Sets whether the approve & cancel buttons are shown.") public void setControlButtonsAreShown(boolean b)
Sets the property that indicates whether the approve and cancel buttons are shown in the file chooser. This property is `true` by default. Look and feels that always show these buttons will ignore the value of this property. This method fires a property-changed event, using the string value of `CONTROL_BUTTONS_ARE_SHOWN_CHANGED_PROPERTY` as the name of the property.

Parameters:
  `b` - `false` if control buttons should not be shown; otherwise, `true`
Since:
  1.3
See Also:
  - `getControlButtonsAreShown()`
  - `CONTROL_BUTTONS_ARE_SHOWN_CHANGED_PROPERTY`

### getDialogType

public int getDialogType()
Returns the type of this dialog. The default is `JFileChooser.OPEN_DIALOG`.

Returns:
  the type of dialog to be displayed:
  - JFileChooser.OPEN_DIALOG
  - JFileChooser.SAVE_DIALOG
  - JFileChooser.CUSTOM_DIALOG
See Also:
  - `setDialogType(int)`

### setDialogType

@BeanProperty(preferred=true, enumerationValues={"JFileChooser.OPEN_DIALOG","JFileChooser.SAVE_DIALOG","JFileChooser.CUSTOM_DIALOG"}, description="The type (open, save, custom) of the JFileChooser.") public void setDialogType(int dialogType)
Sets the type of this dialog. Use `OPEN_DIALOG` when you want to bring up a file chooser that the user can use to open a file. Likewise, use `SAVE_DIALOG` for letting the user choose a file for saving. Use `CUSTOM_DIALOG` when you want to use the file chooser in a context other than "Open" or "Save". For instance, you might want to bring up a file chooser that allows the user to choose a file to execute. Note that you normally would not need to set the `JFileChooser` to use `CUSTOM_DIALOG` since a call to `setApproveButtonText` does this for you. The default dialog type is `JFileChooser.OPEN_DIALOG`.

Parameters:
  `dialogType` - the type of dialog to be displayed:
  - JFileChooser.OPEN_DIALOG
  - JFileChooser.SAVE_DIALOG
  - JFileChooser.CUSTOM_DIALOG
Throws:
  `IllegalArgumentException` - if `dialogType` is not legal
See Also:
  - `getDialogType()`
  - `setApproveButtonText(String)`

### setDialogTitle

@BeanProperty(preferred=true, description="The title of the JFileChooser dialog window.") public void setDialogTitle(String dialogTitle)
Sets the string that goes in the `JFileChooser` window's title bar.

Parameters:
  `dialogTitle` - the new `String` for the title bar
See Also:
  - `getDialogTitle()`

### getDialogTitle

public String getDialogTitle()
Gets the string that goes in the `JFileChooser`'s titlebar.

Returns:
  the string from the `JFileChooser` window's title bar
See Also:
  - `setDialogTitle(String)`

### setApproveButtonToolTipText

@BeanProperty(preferred=true, description="The tooltip text for the ApproveButton.") public void setApproveButtonToolTipText(String toolTipText)
Sets the tooltip text used in the `ApproveButton`. If `null`, the UI object will determine the button's text.

Parameters:
  `toolTipText` - the tooltip text for the approve button
See Also:
  - `setApproveButtonText(String)`
  - `setDialogType(int)`
  - `showDialog(Component, String)`

### getApproveButtonToolTipText

public String getApproveButtonToolTipText()
Returns the tooltip text used in the `ApproveButton`. If `null`, the UI object will determine the button's text.

Returns:
  the tooltip text used for the approve button
See Also:
  - `setApproveButtonText(String)`
  - `setDialogType(int)`
  - `showDialog(Component, String)`

### getApproveButtonMnemonic

public int getApproveButtonMnemonic()
Returns the approve button's mnemonic.

Returns:
  an integer value for the mnemonic key
See Also:
  - `setApproveButtonMnemonic(int)`

### setApproveButtonMnemonic

@BeanProperty(preferred=true, description="The mnemonic key accelerator for the ApproveButton.") public void setApproveButtonMnemonic(int mnemonic)
Sets the approve button's mnemonic using a numeric keycode.

Parameters:
  `mnemonic` - an integer value for the mnemonic key
See Also:
  - `getApproveButtonMnemonic()`

### setApproveButtonMnemonic

public void setApproveButtonMnemonic(char mnemonic)
Sets the approve button's mnemonic using a character.

Parameters:
  `mnemonic` - a character value for the mnemonic key
See Also:
  - `getApproveButtonMnemonic()`

### setApproveButtonText

@BeanProperty(preferred=true, description="The text that goes in the ApproveButton.") public void setApproveButtonText(String approveButtonText)
Sets the text used in the `ApproveButton` in the `FileChooserUI`.

Parameters:
  `approveButtonText` - the text used in the `ApproveButton`
See Also:
  - `getApproveButtonText()`
  - `setDialogType(int)`
  - `showDialog(Component, String)`

### getApproveButtonText

public String getApproveButtonText()
Returns the text used in the `ApproveButton` in the `FileChooserUI`. If `null`, the UI object will determine the button's text. Typically, this would be "Open" or "Save".

Returns:
  the text used in the `ApproveButton`
See Also:
  - `setApproveButtonText(String)`
  - `setDialogType(int)`
  - `showDialog(Component, String)`

### getChoosableFileFilters

@BeanProperty(bound=false) public FileFilter[] getChoosableFileFilters()
Gets the list of user choosable file filters.

Returns:
  a `FileFilter` array containing all the choosable file filters
See Also:
  - `addChoosableFileFilter(FileFilter)`
  - `removeChoosableFileFilter(FileFilter)`
  - `resetChoosableFileFilters()`

### addChoosableFileFilter

@BeanProperty(preferred=true, description="Adds a filter to the list of user choosable file filters.") public void addChoosableFileFilter(FileFilter filter)
Adds a filter to the list of user choosable file filters. For information on setting the file selection mode, see `setFileSelectionMode`.

Parameters:
  `filter` - the `FileFilter` to add to the choosable file filter list
See Also:
  - `getChoosableFileFilters()`
  - `removeChoosableFileFilter(FileFilter)`
  - `resetChoosableFileFilters()`
  - `setFileSelectionMode(int)`

### removeChoosableFileFilter

public boolean removeChoosableFileFilter(FileFilter f)
Removes a filter from the list of user choosable file filters. Returns true if the file filter was removed.

Parameters:
  `f` - the file filter to be removed
Returns:
  true if the file filter was removed, false otherwise
See Also:
  - `addChoosableFileFilter(FileFilter)`
  - `getChoosableFileFilters()`
  - `resetChoosableFileFilters()`

### resetChoosableFileFilters

public void resetChoosableFileFilters()
Resets the choosable file filter list to its starting state. Normally, this removes all added file filters while leaving the `AcceptAll` file filter.

See Also:
  - `addChoosableFileFilter(FileFilter)`
  - `getChoosableFileFilters()`
  - `removeChoosableFileFilter(FileFilter)`

### getAcceptAllFileFilter

@BeanProperty(bound=false) public FileFilter getAcceptAllFileFilter()
Returns the `AcceptAll` file filter. For example, on Microsoft Windows this would be All Files (*.*).

Returns:
  the `AcceptAll` file filter

### isAcceptAllFileFilterUsed

public boolean isAcceptAllFileFilterUsed()
Returns whether the `AcceptAll FileFilter` is used.

Returns:
  true if the `AcceptAll FileFilter` is used
Since:
  1.3
See Also:
  - `setAcceptAllFileFilterUsed(boolean)`

### setAcceptAllFileFilterUsed

@BeanProperty(preferred=true, description="Sets whether the AcceptAll FileFilter is used as an available choice in the choosable filter list.") public void setAcceptAllFileFilterUsed(boolean b)
Determines whether the `AcceptAll FileFilter` is used as an available choice in the choosable filter list. If false, the `AcceptAll` file filter is removed from the list of available file filters. If true, the `AcceptAll` file filter will become the actively used file filter.

Parameters:
  `b` - a `boolean` which determines whether the `AcceptAll` file filter is an available choice in the choosable filter list
Since:
  1.3
See Also:
  - `isAcceptAllFileFilterUsed()`
  - `getAcceptAllFileFilter()`
  - `setFileFilter(FileFilter)`

### getAccessory

public JComponent getAccessory()
Returns the accessory component.

Returns:
  this JFileChooser's accessory component, or null
See Also:
  - `setAccessory(JComponent)`

### setAccessory

@BeanProperty(preferred=true, description="Sets the accessory component on the JFileChooser.") public void setAccessory(JComponent newAccessory)
Sets the accessory component. An accessory is often used to show a preview image of the selected file; however, it can be used for anything that the programmer wishes, such as extra custom file chooser controls.

Note: if there was a previous accessory, you should unregister any listeners that the accessory might have registered with the file chooser.

Parameters:
  `newAccessory` - the accessory component to be set

### setFileSelectionMode

@BeanProperty(preferred=true, enumerationValues={"JFileChooser.FILES_ONLY","JFileChooser.DIRECTORIES_ONLY","JFileChooser.FILES_AND_DIRECTORIES"}, description="Sets the types of files that the JFileChooser can choose.") public void setFileSelectionMode(int mode)
Sets the `JFileChooser` to allow the user to just select files, just select directories, or select both files and directories. The default is `JFilesChooser.FILES_ONLY`.

Parameters:
  `mode` - the type of files to be displayed:
  - JFileChooser.FILES_ONLY
  - JFileChooser.DIRECTORIES_ONLY
  - JFileChooser.FILES_AND_DIRECTORIES
Throws:
  `IllegalArgumentException` - if `mode` is an illegal file selection mode
See Also:
  - `getFileSelectionMode()`

### getFileSelectionMode

public int getFileSelectionMode()
Returns the current file-selection mode. The default is `JFilesChooser.FILES_ONLY`.

Returns:
  the type of files to be displayed, one of the following:
  - JFileChooser.FILES_ONLY
  - JFileChooser.DIRECTORIES_ONLY
  - JFileChooser.FILES_AND_DIRECTORIES
See Also:
  - `setFileSelectionMode(int)`

### isFileSelectionEnabled

@BeanProperty(bound=false) public boolean isFileSelectionEnabled()
Convenience call that determines if files are selectable based on the current file selection mode.

Returns:
  true if files are selectable, false otherwise
See Also:
  - `setFileSelectionMode(int)`
  - `getFileSelectionMode()`

### isDirectorySelectionEnabled

@BeanProperty(bound=false) public boolean isDirectorySelectionEnabled()
Convenience call that determines if directories are selectable based on the current file selection mode.

Returns:
  true if directories are selectable, false otherwise
See Also:
  - `setFileSelectionMode(int)`
  - `getFileSelectionMode()`

### setMultiSelectionEnabled

@BeanProperty(description="Sets multiple file selection mode.") public void setMultiSelectionEnabled(boolean b)
Sets the file chooser to allow multiple file selections.

Parameters:
  `b` - true if multiple files may be selected
See Also:
  - `isMultiSelectionEnabled()`

### isMultiSelectionEnabled

public boolean isMultiSelectionEnabled()
Returns true if multiple files can be selected.

Returns:
  true if multiple files can be selected
See Also:
  - `setMultiSelectionEnabled(boolean)`

### isFileHidingEnabled

public boolean isFileHidingEnabled()
Returns true if hidden files are not shown in the file chooser; otherwise, returns false. The default value of this property may be derived from the underlying Operating System.

Returns:
  the status of the file hiding property
See Also:
  - `setFileHidingEnabled(boolean)`

### setFileHidingEnabled

@BeanProperty(preferred=true, description="Sets file hiding on or off.") public void setFileHidingEnabled(boolean b)
Sets file hiding on or off. If true, hidden files are not shown in the file chooser. The job of determining which files are shown is done by the `FileView`.

Parameters:
  `b` - the boolean value that determines whether file hiding is turned on
See Also:
  - `isFileHidingEnabled()`

### setFileFilter

@BeanProperty(preferred=true, description="Sets the File Filter used to filter out files of type.") public void setFileFilter(FileFilter filter)
Sets the current file filter. The file filter is used by the file chooser to filter out files from the user's view.

Parameters:
  `filter` - the new current file filter to use
See Also:
  - `getFileFilter()`

### getFileFilter

public FileFilter getFileFilter()
Returns the currently selected file filter.

Returns:
  the current file filter
See Also:
  - `setFileFilter(FileFilter)`
  - `addChoosableFileFilter(FileFilter)`

### setFileView

@BeanProperty(preferred=true, description="Sets the File View used to get file type information.") public void setFileView(FileView fileView)
Sets the file view to be used to retrieve UI information, such as the icon that represents a file or the type description of a file.

Parameters:
  `fileView` - a `FileView` to be used to retrieve UI information
See Also:
  - `getFileView()`

### getFileView

public FileView getFileView()
Returns the current file view.

Returns:
  the current file view
See Also:
  - `setFileView(FileView)`

### getName

public String getName(File f)
Returns the filename.

Parameters:
  `f` - the `File`
Returns:
  the `String` containing the filename for `f`
See Also:
  - `FileView.getName(File)`

### getDescription

public String getDescription(File f)
Returns the file description.

Parameters:
  `f` - the `File`
Returns:
  the `String` containing the file description for `f`
See Also:
  - `FileView.getDescription(File)`

### getTypeDescription

public String getTypeDescription(File f)
Returns the file type.

Parameters:
  `f` - the `File`
Returns:
  the `String` containing the file type description for `f`
See Also:
  - `FileView.getTypeDescription(File)`

### getIcon

public Icon getIcon(File f)
Returns the icon for this file or type of file, depending on the system.

Parameters:
  `f` - the `File`
Returns:
  the `Icon` for this file, or type of file
See Also:
  - `FileView.getIcon(File)`

### isTraversable

public boolean isTraversable(File f)
Returns true if the file (directory) can be visited. Returns false if the directory cannot be traversed.

Parameters:
  `f` - the `File`
Returns:
  true if the file/directory can be traversed, otherwise false
See Also:
  - `FileView.isTraversable(File)`

### accept

public boolean accept(File f)
Returns true if the file should be displayed.

Parameters:
  `f` - the `File`
Returns:
  true if the file should be displayed, otherwise false
See Also:
  - `FileFilter.accept(File)`

### setFileSystemView

@BeanProperty(expert=true, description="Sets the FileSystemView used to get filesystem information.") public void setFileSystemView(FileSystemView fsv)
Sets the file system view that the `JFileChooser` uses for accessing and creating file system resources, such as finding the floppy drive and getting a list of root drives.

Parameters:
  `fsv` - the new `FileSystemView`
See Also:
  - `FileSystemView`

### getFileSystemView

public FileSystemView getFileSystemView()
Returns the file system view.

Returns:
  the `FileSystemView` object
See Also:
  - `setFileSystemView(FileSystemView)`

### approveSelection

public void approveSelection()
Called by the UI when the user hits the Approve button (labeled "Open" or "Save", by default). This can also be called by the programmer. This method causes an action event to fire with the command string equal to `APPROVE_SELECTION`.

See Also:
  - `APPROVE_SELECTION`

### cancelSelection

public void cancelSelection()
Called by the UI when the user chooses the Cancel button. This can also be called by the programmer. This method causes an action event to fire with the command string equal to `CANCEL_SELECTION`.

See Also:
  - `CANCEL_SELECTION`

### addActionListener

public void addActionListener(ActionListener l)
Adds an `ActionListener` to the file chooser.

Parameters:
  `l` - the listener to be added
See Also:
  - `approveSelection()`
  - `cancelSelection()`

### removeActionListener

public void removeActionListener(ActionListener l)
Removes an `ActionListener` from the file chooser.

Parameters:
  `l` - the listener to be removed
See Also:
  - `addActionListener(ActionListener)`

### getActionListeners

@BeanProperty(bound=false) public ActionListener[] getActionListeners()
Returns an array of all the action listeners registered on this file chooser.

Returns:
  all of this file chooser's `ActionListener`s or an empty array if no action listeners are currently registered
Since:
  1.4
See Also:
  - `addActionListener(ActionListener)`
  - `removeActionListener(ActionListener)`

### fireActionPerformed

protected void fireActionPerformed(String command)
Notifies all listeners that have registered interest for notification on this event type. The event instance is lazily created using the `command` parameter.

Parameters:
  `command` - a string that may specify a command associated with the event
See Also:
  - `EventListenerList`

### updateUI

public void updateUI()
Resets the UI property to a value from the current look and feel.

Overrides:
  `updateUI` in class `JComponent`
See Also:
  - `JComponent.updateUI()`

### getUIClassID

@BeanProperty(bound=false, expert=true, description="A string that specifies the name of the L&F class.") public String getUIClassID()
Returns a string that specifies the name of the L&F class that renders this component.

Overrides:
  `getUIClassID` in class `JComponent`
Returns:
  the string "FileChooserUI"
See Also:
  - `JComponent.getUIClassID()`
  - `UIDefaults.getUI(JComponent)`

### getUI

@BeanProperty(bound=false) public FileChooserUI getUI()
Gets the UI object which implements the L&F for this component.

Overrides:
  `getUI` in class `JComponent`
Returns:
  the FileChooserUI object that implements the FileChooserUI L&F

### paramString

protected String paramString()
Returns a string representation of this `JFileChooser`. This method is intended to be used only for debugging purposes, and the content and format of the returned string may vary between implementations. The returned string may be empty but may not be `null`.

Overrides:
  `paramString` in class `JComponent`
Returns:
  a string representation of this `JFileChooser`

### getAccessibleContext

@BeanProperty(bound=false) public AccessibleContext getAccessibleContext()
Gets the AccessibleContext associated with this JFileChooser. For file choosers, the AccessibleContext takes the form of an AccessibleJFileChooser. A new AccessibleJFileChooser instance is created if necessary.

Specified by:
  `getAccessibleContext` in interface `Accessible`
Overrides:
  `getAccessibleContext` in class `Component`
Returns:
  an AccessibleJFileChooser that serves as the AccessibleContext of this JFileChooser

### setEnabled

public void setEnabled(boolean enabled)
Sets whether or not this component is enabled. A component that is enabled may respond to user input, while a component that is not enabled cannot respond to user input. Some components may alter their visual representation when they are disabled in order to provide feedback to the user that they cannot take input.

Note: Disabling a component does not disable its children.

Note: Disabling a lightweight component does not prevent it from receiving MouseEvents.

Overrides:
  `setEnabled` in class `JComponent`
Parameters:
  `enabled` - true if this component should be enabled, false otherwise
See Also:
  - `Component.isEnabled()`
  - `Component.isLightweight()`